Subject: Re: BCM5719(tg3) use multiple MSI with RSS

From: Mike Qiu <[email-masked]>
Date: Thu, 16 May 2013 10:30:36 +0800

于 2013/5/16 0:03, Michael Chan 写道:
> On Wed, 2013-05-15 at 16:52 +0100, Ben Hutchings wrote:
>> On Wed, 2013-05-15 at 08:08 -0700, Michael Chan wrote:
>>> On Wed, 2013-05-15 at 15:56 +0800, Mike Qiu wrote:
>>>> Hi all
>>>>
>>>> Currently, I need to enable multiple MSI on BCM5719 network card.
>>>> But I look in to the spec of 5719 from Broadcom, it seems
>>>> that RSS just enable with MSI-X, so I'm not sure if multiple
>>>> MSI can use RSS.
>>>>
>>> MSI can only support one IRQ source and cannot support RSS.
>> It is possible for an MSI capability to have multiple MSIs, but they
>> will use the same address and consecutive data values.
>>
>> On x86, if you can find a large enough block of free IRQs on an IOAPIC,
>> it is possible to implement RSS this way.  Linux supports this on
>> systems with an x2apic.
>>
>> Now, maybe tg3 hardware doesn't support this (and really, why bother
>> when there is MSI-X?) but the option does exist.
> Yes, tg3 hardware (may be all Broadcom hardware) can only use MSI as a
> replacement for INTA.
That you mean, it can't use multiple MSI for RSS ?